<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.jid</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        Module&nbsp;jid
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pyxmpp.jid-module.html">Module pyxmpp.jid</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"># (C) Copyright 2003-2010 Jacek Konieczny &lt;jajcus@jajcus.net&gt;</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"># This program is free software; you can redistribute it and/or modify</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment"># it under the terms of the GNU Lesser General Public License Version</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"># 2.1 as published by the Free Software Foundation.</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"># This program is distributed in the hope that it will be useful,</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment"># GNU Lesser General Public License for more details.</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"># You should have received a copy of the GNU Lesser General Public</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"># License along with this program; if not, write to the Free Software</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"># Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"><tt class="py-comment"># pylint: disable-msg=W0232, E0201</tt> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"><tt class="py-docstring">"""jid -- Jabber ID handling</tt> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"><tt class="py-docstring">Normative reference:</tt> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"><tt class="py-docstring">  - `RFC 3920 &lt;http://www.ietf.org/rfc/rfc3920.txt&gt;`__</tt> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"><tt class="py-docstring">"""</tt> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"><tt class="py-name">__docformat__</tt><tt class="py-op">=</tt><tt class="py-string">"restructuredtext en"</tt> </tt>
<a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line"> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">re</tt> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">weakref</tt> </tt>
<a name="L29"></a><tt class="py-lineno"> 29</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">warnings</tt> </tt>
<a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line"> </tt>
<a name="L31"></a><tt class="py-lineno"> 31</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-name">encodings</tt> <tt class="py-keyword">import</tt> <tt class="py-name">idna</tt> </tt>
<a name="L32"></a><tt class="py-lineno"> 32</tt>  <tt class="py-line"> </tt>
<a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-0" class="py-name" targets="Package pyxmpp=pyxmpp-module.html"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-0', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-1" class="py-name" targets="Module pyxmpp.xmppstringprep=pyxmpp.xmppstringprep-module.html"><a title="pyxmpp.xmppstringprep" class="py-name" href="#" onclick="return doclink('link-1', 'xmppstringprep', 'link-1');">xmppstringprep</a></tt> <tt class="py-keyword">import</tt> <tt id="link-2" class="py-name" targets="Variable pyxmpp.xmppstringprep.nodeprep=pyxmpp.xmppstringprep-module.html#nodeprep"><a title="pyxmpp.xmppstringprep.nodeprep" class="py-name" href="#" onclick="return doclink('link-2', 'nodeprep', 'link-2');">nodeprep</a></tt><tt class="py-op">,</tt><tt id="link-3" class="py-name" targets="Variable pyxmpp.xmppstringprep.resourceprep=pyxmpp.xmppstringprep-module.html#resourceprep"><a title="pyxmpp.xmppstringprep.resourceprep" class="py-name" href="#" onclick="return doclink('link-3', 'resourceprep', 'link-3');">resourceprep</a></tt> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-4" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-4', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-5" class="py-name" targets="Module pyxmpp.exceptions=pyxmpp.exceptions-module.html"><a title="pyxmpp.exceptions" class="py-name" href="#" onclick="return doclink('link-5', 'exceptions', 'link-5');">exceptions</a></tt> <tt class="py-keyword">import</tt> <tt id="link-6" class="py-name" targets="Class pyxmpp.exceptions.JIDError=pyxmpp.exceptions.JIDError-class.html"><a title="pyxmpp.exceptions.JIDError" class="py-name" href="#" onclick="return doclink('link-6', 'JIDError', 'link-6');">JIDError</a></tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line"> </tt>
<a name="L36"></a><tt class="py-lineno"> 36</tt>  <tt class="py-line"><tt id="link-7" class="py-name" targets="Variable pyxmpp.jid.node_invalid_re=pyxmpp.jid-module.html#node_invalid_re"><a title="pyxmpp.jid.node_invalid_re" class="py-name" href="#" onclick="return doclink('link-7', 'node_invalid_re', 'link-7');">node_invalid_re</a></tt><tt class="py-op">=</tt><tt class="py-name">re</tt><tt class="py-op">.</tt><tt class="py-name">compile</tt><tt class="py-op">(</tt><tt class="py-string">ur"["</tt> <tt class="py-string">u'"'</tt> <tt class="py-string">ur"&amp;'/:&lt;&gt;@\s\x00-\x19]"</tt><tt class="py-op">,</tt><tt class="py-name">re</tt><tt class="py-op">.</tt><tt class="py-name">UNICODE</tt><tt class="py-op">)</tt> </tt>
<a name="L37"></a><tt class="py-lineno"> 37</tt>  <tt class="py-line"><tt id="link-8" class="py-name" targets="Variable pyxmpp.jid.resource_invalid_re=pyxmpp.jid-module.html#resource_invalid_re"><a title="pyxmpp.jid.resource_invalid_re" class="py-name" href="#" onclick="return doclink('link-8', 'resource_invalid_re', 'link-8');">resource_invalid_re</a></tt><tt class="py-op">=</tt><tt class="py-name">re</tt><tt class="py-op">.</tt><tt class="py-name">compile</tt><tt class="py-op">(</tt><tt class="py-string">ur"[\s\x00-\x19]"</tt><tt class="py-op">,</tt><tt class="py-name">re</tt><tt class="py-op">.</tt><tt class="py-name">UNICODE</tt><tt class="py-op">)</tt> </tt>
<a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line"> </tt>
<a name="are_domains_equal"></a><div id="are_domains_equal-def"><a name="L39"></a><tt class="py-lineno"> 39</tt> <a class="py-toggle" href="#" id="are_domains_equal-toggle" onclick="return toggle('are_domains_equal');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid-module.html#are_domains_equal">are_domains_equal</a><tt class="py-op">(</tt><tt class="py-param">a</tt><tt class="py-op">,</tt><tt class="py-param">b</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="are_domains_equal-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="are_domains_equal-expanded"><a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line">    <tt class="py-docstring">"""Compare two International Domain Names.</tt> </tt>
<a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L43"></a><tt class="py-lineno"> 43</tt>  <tt class="py-line"><tt class="py-docstring">        - `a`,`b`: domains names to compare</tt> </tt>
<a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L45"></a><tt class="py-lineno"> 45</tt>  <tt class="py-line"><tt class="py-docstring">    :return: True `a` and `b` are equal as domain names."""</tt> </tt>
<a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line"> </tt>
<a name="L47"></a><tt class="py-lineno"> 47</tt>  <tt class="py-line">    <tt class="py-name">a</tt><tt class="py-op">=</tt><tt class="py-name">idna</tt><tt class="py-op">.</tt><tt class="py-name">ToASCII</tt><tt class="py-op">(</tt><tt class="py-name">a</tt><tt class="py-op">)</tt> </tt>
<a name="L48"></a><tt class="py-lineno"> 48</tt>  <tt class="py-line">    <tt class="py-name">b</tt><tt class="py-op">=</tt><tt class="py-name">idna</tt><tt class="py-op">.</tt><tt class="py-name">ToASCII</tt><tt class="py-op">(</tt><tt class="py-name">b</tt><tt class="py-op">)</tt> </tt>
<a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line">    <tt class="py-keyword">return</tt> <tt class="py-name">a</tt><tt class="py-op">.</tt><tt class="py-name">lower</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">==</tt><tt class="py-name">b</tt><tt class="py-op">.</tt><tt class="py-name">lower</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line"> </tt>
<a name="JID"></a><div id="JID-def"><a name="L51"></a><tt class="py-lineno"> 51</tt> <a class="py-toggle" href="#" id="JID-toggle" onclick="return toggle('JID');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html">JID</a><tt class="py-op">(</tt><tt class="py-base-class">object</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="JID-expanded"><a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line">    <tt class="py-docstring">"""JID.</tt> </tt>
<a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line"><tt class="py-docstring">    :Ivariables:</tt> </tt>
<a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line"><tt class="py-docstring">        - `node`: node part of the JID</tt> </tt>
<a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line"><tt class="py-docstring">        - `domain`: domain part of the JID</tt> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line"><tt class="py-docstring">        - `resource`: resource part of the JID</tt> </tt>
<a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L59"></a><tt class="py-lineno"> 59</tt>  <tt class="py-line"><tt class="py-docstring">    JID objects are immutable. They are also cached for better performance.</tt> </tt>
<a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line"><tt class="py-docstring">    """</tt> </tt>
<a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line">    <tt id="link-9" class="py-name" targets="Module pyxmpp.cache=pyxmpp.cache-module.html,Variable pyxmpp.jid.JID.cache=pyxmpp.jid.JID-class.html#cache"><a title="pyxmpp.cache
pyxmpp.jid.JID.cache" class="py-name" href="#" onclick="return doclink('link-9', 'cache', 'link-9');">cache</a></tt><tt class="py-op">=</tt><tt class="py-name">weakref</tt><tt class="py-op">.</tt><tt class="py-name">WeakValueDictionary</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line">    <tt class="py-name">__slots__</tt><tt class="py-op">=</tt><tt class="py-op">[</tt><tt class="py-string">"node"</tt><tt class="py-op">,</tt><tt class="py-string">"domain"</tt><tt class="py-op">,</tt><tt class="py-string">"resource"</tt><tt class="py-op">,</tt><tt class="py-string">"__weakref__"</tt><tt class="py-op">]</tt> </tt>
<a name="JID.__new__"></a><div id="JID.__new__-def"><a name="L63"></a><tt class="py-lineno"> 63</tt> <a class="py-toggle" href="#" id="JID.__new__-toggle" onclick="return toggle('JID.__new__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__new__">__new__</a><tt class="py-op">(</tt><tt class="py-param">cls</tt><tt class="py-op">,</tt><tt class="py-param">node_or_jid</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-param">domain</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-param">resource</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-param">check</tt><tt class="py-op">=</tt><tt class="py-name">True</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__new__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__new__-expanded"><a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line">        <tt class="py-docstring">"""Create a new JID object or take one from the cache.</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line"><tt class="py-docstring">            - `node_or_jid`: node part of the JID, JID object to copy or</tt> </tt>
<a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line"><tt class="py-docstring">              Unicode representation of the JID.</tt> </tt>
<a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line"><tt class="py-docstring">            - `domain`: domain part of the JID</tt> </tt>
<a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line"><tt class="py-docstring">            - `resource`: resource part of the JID</tt> </tt>
<a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line"><tt class="py-docstring">            - `check`: if `False` then JID is not checked for specifiaction</tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line"><tt class="py-docstring">              compliance.</tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line"> </tt>
<a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt class="py-name">node_or_jid</tt><tt class="py-op">,</tt><tt id="link-10" class="py-name" targets="Class pyxmpp.jid.JID=pyxmpp.jid.JID-class.html"><a title="pyxmpp.jid.JID" class="py-name" href="#" onclick="return doclink('link-10', 'JID', 'link-10');">JID</a></tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L76"></a><tt class="py-lineno"> 76</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">node_or_jid</tt> </tt>
<a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line"> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt id="link-11" class="py-name" targets="Variable pyxmpp.jid.JID.domain=pyxmpp.jid.JID-class.html#domain"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-11', 'domain', 'link-11');">domain</a></tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt> <tt class="py-keyword">and</tt> <tt id="link-12" class="py-name" targets="Variable pyxmpp.jid.JID.resource=pyxmpp.jid.JID-class.html#resource"><a title="pyxmpp.jid.JID.resource" class="py-name" href="#" onclick="return doclink('link-12', 'resource', 'link-12');">resource</a></tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line">            <tt class="py-name">obj</tt><tt class="py-op">=</tt><tt class="py-name">cls</tt><tt class="py-op">.</tt><tt id="link-13" class="py-name"><a title="pyxmpp.cache
pyxmpp.jid.JID.cache" class="py-name" href="#" onclick="return doclink('link-13', 'cache', 'link-9');">cache</a></tt><tt class="py-op">.</tt><tt class="py-name">get</tt><tt class="py-op">(</tt><tt class="py-name">node_or_jid</tt><tt class="py-op">)</tt> </tt>
<a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">obj</tt><tt class="py-op">:</tt> </tt>
<a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">obj</tt> </tt>
<a name="L82"></a><tt class="py-lineno"> 82</tt>  <tt class="py-line">        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line">            <tt class="py-name">obj</tt><tt class="py-op">=</tt><tt class="py-name">None</tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">obj</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line">            <tt class="py-name">obj</tt><tt class="py-op">=</tt><tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-14" class="py-name" targets="Static Method pyxmpp.jid.JID.__new__()=pyxmpp.jid.JID-class.html#__new__"><a title="pyxmpp.jid.JID.__new__" class="py-name" href="#" onclick="return doclink('link-14', '__new__', 'link-14');">__new__</a></tt><tt class="py-op">(</tt><tt class="py-name">cls</tt><tt class="py-op">)</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line"> </tt>
<a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">node_or_jid</tt><tt class="py-op">:</tt> </tt>
<a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line">            <tt class="py-name">node_or_jid</tt> <tt class="py-op">=</tt> <tt class="py-name">unicode</tt><tt class="py-op">(</tt><tt class="py-name">node_or_jid</tt><tt class="py-op">)</tt> </tt>
<a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-op">(</tt><tt class="py-name">node_or_jid</tt> <tt class="py-keyword">and</tt> </tt>
<a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line">                <tt class="py-op">(</tt><tt class="py-op">(</tt><tt class="py-string">u"@"</tt> <tt class="py-keyword">in</tt> <tt class="py-name">node_or_jid</tt><tt class="py-op">)</tt> <tt class="py-keyword">or</tt> <tt class="py-op">(</tt><tt class="py-string">u"/"</tt> <tt class="py-keyword">in</tt> <tt class="py-name">node_or_jid</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line">            <tt class="py-name">obj</tt><tt class="py-op">.</tt><tt id="link-15" class="py-name" targets="Method pyxmpp.jid.JID.__from_unicode()=pyxmpp.jid.JID-class.html#__from_unicode"><a title="pyxmpp.jid.JID.__from_unicode" class="py-name" href="#" onclick="return doclink('link-15', '__from_unicode', 'link-15');">__from_unicode</a></tt><tt class="py-op">(</tt><tt class="py-name">node_or_jid</tt><tt class="py-op">)</tt> </tt>
<a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line">            <tt class="py-name">cls</tt><tt class="py-op">.</tt><tt id="link-16" class="py-name"><a title="pyxmpp.cache
pyxmpp.jid.JID.cache" class="py-name" href="#" onclick="return doclink('link-16', 'cache', 'link-9');">cache</a></tt><tt class="py-op">[</tt><tt class="py-name">node_or_jid</tt><tt class="py-op">]</tt><tt class="py-op">=</tt><tt class="py-name">obj</tt> </tt>
<a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line">        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt id="link-17" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-17', 'domain', 'link-11');">domain</a></tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt> <tt class="py-keyword">and</tt> <tt id="link-18" class="py-name"><a title="pyxmpp.jid.JID.resource" class="py-name" href="#" onclick="return doclink('link-18', 'resource', 'link-12');">resource</a></tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">node_or_jid</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line">                    <tt class="py-keyword">raise</tt> <tt id="link-19" class="py-name"><a title="pyxmpp.exceptions.JIDError" class="py-name" href="#" onclick="return doclink('link-19', 'JIDError', 'link-6');">JIDError</a></tt><tt class="py-op">,</tt><tt class="py-string">"At least domain must be given"</tt> </tt>
<a name="L97"></a><tt class="py-lineno"> 97</tt>  <tt class="py-line">                <tt id="link-20" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-20', 'domain', 'link-11');">domain</a></tt><tt class="py-op">=</tt><tt class="py-name">node_or_jid</tt> </tt>
<a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line">                <tt class="py-name">node_or_jid</tt><tt class="py-op">=</tt><tt class="py-name">None</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">check</tt><tt class="py-op">:</tt> </tt>
<a name="L100"></a><tt class="py-lineno">100</tt>  <tt class="py-line">                <tt class="py-name">obj</tt><tt class="py-op">.</tt><tt id="link-21" class="py-name" targets="Method pyxmpp.jid.JID.__set_node()=pyxmpp.jid.JID-class.html#__set_node"><a title="pyxmpp.jid.JID.__set_node" class="py-name" href="#" onclick="return doclink('link-21', '__set_node', 'link-21');">__set_node</a></tt><tt class="py-op">(</tt><tt class="py-name">node_or_jid</tt><tt class="py-op">)</tt> </tt>
<a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line">                <tt class="py-name">obj</tt><tt class="py-op">.</tt><tt id="link-22" class="py-name" targets="Method pyxmpp.jid.JID.__set_domain()=pyxmpp.jid.JID-class.html#__set_domain"><a title="pyxmpp.jid.JID.__set_domain" class="py-name" href="#" onclick="return doclink('link-22', '__set_domain', 'link-22');">__set_domain</a></tt><tt class="py-op">(</tt><tt id="link-23" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-23', 'domain', 'link-11');">domain</a></tt><tt class="py-op">)</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line">                <tt class="py-name">obj</tt><tt class="py-op">.</tt><tt id="link-24" class="py-name" targets="Method pyxmpp.jid.JID.__set_resource()=pyxmpp.jid.JID-class.html#__set_resource"><a title="pyxmpp.jid.JID.__set_resource" class="py-name" href="#" onclick="return doclink('link-24', '__set_resource', 'link-24');">__set_resource</a></tt><tt class="py-op">(</tt><tt id="link-25" class="py-name"><a title="pyxmpp.jid.JID.resource" class="py-name" href="#" onclick="return doclink('link-25', 'resource', 'link-12');">resource</a></tt><tt class="py-op">)</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line">                <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-26" class="py-name" targets="Method pyxmpp.jabber.dataforms.Field.__setattr__()=pyxmpp.jabber.dataforms.Field-class.html#__setattr__,Method pyxmpp.jid.JID.__setattr__()=pyxmpp.jid.JID-class.html#__setattr__"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-26', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">obj</tt><tt class="py-op">,</tt><tt class="py-string">"node"</tt><tt class="py-op">,</tt><tt class="py-name">node_or_jid</tt><tt class="py-op">)</tt> </tt>
<a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line">                <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-27" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-27', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">obj</tt><tt class="py-op">,</tt><tt class="py-string">"domain"</tt><tt class="py-op">,</tt><tt id="link-28" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-28', 'domain', 'link-11');">domain</a></tt><tt class="py-op">)</tt> </tt>
<a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line">                <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-29" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-29', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">obj</tt><tt class="py-op">,</tt><tt class="py-string">"resource"</tt><tt class="py-op">,</tt><tt id="link-30" class="py-name"><a title="pyxmpp.jid.JID.resource" class="py-name" href="#" onclick="return doclink('link-30', 'resource', 'link-12');">resource</a></tt><tt class="py-op">)</tt> </tt>
<a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">obj</tt> </tt>
</div><a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line"> </tt>
<a name="JID.__setattr__"></a><div id="JID.__setattr__-def"><a name="L109"></a><tt class="py-lineno">109</tt> <a class="py-toggle" href="#" id="JID.__setattr__-toggle" onclick="return toggle('JID.__setattr__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__setattr__">__setattr__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">name</tt><tt class="py-op">,</tt><tt class="py-param">value</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__setattr__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__setattr__-expanded"><a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line">        <tt class="py-keyword">raise</tt> <tt class="py-name">RuntimeError</tt><tt class="py-op">,</tt><tt class="py-string">"JID objects are immutable!"</tt> </tt>
</div><a name="L111"></a><tt class="py-lineno">111</tt>  <tt class="py-line"> </tt>
<a name="JID.__from_unicode"></a><div id="JID.__from_unicode-def"><a name="L112"></a><tt class="py-lineno">112</tt> <a class="py-toggle" href="#" id="JID.__from_unicode-toggle" onclick="return toggle('JID.__from_unicode');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__from_unicode">__from_unicode</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">s</tt><tt class="py-op">,</tt><tt class="py-param">check</tt><tt class="py-op">=</tt><tt class="py-name">True</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__from_unicode-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__from_unicode-expanded"><a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize JID object from Unicode string.</tt> </tt>
<a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L115"></a><tt class="py-lineno">115</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L116"></a><tt class="py-lineno">116</tt>  <tt class="py-line"><tt class="py-docstring">            - `s`: the JID string</tt> </tt>
<a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line"><tt class="py-docstring">            - `check`: when `False` then the JID is not checked for</tt> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line"><tt class="py-docstring">              specification compliance."""</tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line">        <tt class="py-name">s1</tt><tt class="py-op">=</tt><tt class="py-name">s</tt><tt class="py-op">.</tt><tt class="py-name">split</tt><tt class="py-op">(</tt><tt class="py-string">u"/"</tt><tt class="py-op">,</tt><tt class="py-number">1</tt><tt class="py-op">)</tt> </tt>
<a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line">        <tt class="py-name">s2</tt><tt class="py-op">=</tt><tt class="py-name">s1</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt><tt class="py-op">.</tt><tt class="py-name">split</tt><tt class="py-op">(</tt><tt class="py-string">u"@"</tt><tt class="py-op">,</tt><tt class="py-number">1</tt><tt class="py-op">)</tt> </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">len</tt><tt class="py-op">(</tt><tt class="py-name">s2</tt><tt class="py-op">)</tt><tt class="py-op">==</tt><tt class="py-number">2</tt><tt class="py-op">:</tt> </tt>
<a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">check</tt><tt class="py-op">:</tt> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-31" class="py-name"><a title="pyxmpp.jid.JID.__set_node" class="py-name" href="#" onclick="return doclink('link-31', '__set_node', 'link-21');">__set_node</a></tt><tt class="py-op">(</tt><tt class="py-name">s2</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-32" class="py-name"><a title="pyxmpp.jid.JID.__set_domain" class="py-name" href="#" onclick="return doclink('link-32', '__set_domain', 'link-22');">__set_domain</a></tt><tt class="py-op">(</tt><tt class="py-name">s2</tt><tt class="py-op">[</tt><tt class="py-number">1</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L126"></a><tt class="py-lineno">126</tt>  <tt class="py-line">                <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-33" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-33', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-string">"node"</tt><tt class="py-op">,</tt><tt class="py-name">s2</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line">                <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-34" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-34', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-string">"domain"</tt><tt class="py-op">,</tt><tt class="py-name">s2</tt><tt class="py-op">[</tt><tt class="py-number">1</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line">        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">check</tt><tt class="py-op">:</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-35" class="py-name"><a title="pyxmpp.jid.JID.__set_domain" class="py-name" href="#" onclick="return doclink('link-35', '__set_domain', 'link-22');">__set_domain</a></tt><tt class="py-op">(</tt><tt class="py-name">s2</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line">                <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-36" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-36', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-string">"domain"</tt><tt class="py-op">,</tt><tt class="py-name">s2</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line">            <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-37" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-37', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-string">"node"</tt><tt class="py-op">,</tt><tt class="py-name">None</tt><tt class="py-op">)</tt> </tt>
<a name="L134"></a><tt class="py-lineno">134</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">len</tt><tt class="py-op">(</tt><tt class="py-name">s1</tt><tt class="py-op">)</tt><tt class="py-op">==</tt><tt class="py-number">2</tt><tt class="py-op">:</tt> </tt>
<a name="L135"></a><tt class="py-lineno">135</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">check</tt><tt class="py-op">:</tt> </tt>
<a name="L136"></a><tt class="py-lineno">136</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-38" class="py-name"><a title="pyxmpp.jid.JID.__set_resource" class="py-name" href="#" onclick="return doclink('link-38', '__set_resource', 'link-24');">__set_resource</a></tt><tt class="py-op">(</tt><tt class="py-name">s1</tt><tt class="py-op">[</tt><tt class="py-number">1</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line">                <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-39" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-39', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-string">"resource"</tt><tt class="py-op">,</tt><tt class="py-name">s1</tt><tt class="py-op">[</tt><tt class="py-number">1</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line">        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line">            <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-40" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-40', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-string">"resource"</tt><tt class="py-op">,</tt><tt class="py-name">None</tt><tt class="py-op">)</tt> </tt>
<a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-41" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-41', 'domain', 'link-11');">domain</a></tt><tt class="py-op">:</tt> </tt>
<a name="L142"></a><tt class="py-lineno">142</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt id="link-42" class="py-name"><a title="pyxmpp.exceptions.JIDError" class="py-name" href="#" onclick="return doclink('link-42', 'JIDError', 'link-6');">JIDError</a></tt><tt class="py-op">,</tt><tt class="py-string">"Domain is required in JID."</tt> </tt>
</div><a name="L143"></a><tt class="py-lineno">143</tt>  <tt class="py-line"> </tt>
<a name="JID.__set_node"></a><div id="JID.__set_node-def"><a name="L144"></a><tt class="py-lineno">144</tt> <a class="py-toggle" href="#" id="JID.__set_node-toggle" onclick="return toggle('JID.__set_node');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__set_node">__set_node</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">s</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__set_node-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__set_node-expanded"><a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize `self.node`</tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line"><tt class="py-docstring">            - `s`: Node part of the JID</tt> </tt>
<a name="L149"></a><tt class="py-lineno">149</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L150"></a><tt class="py-lineno">150</tt>  <tt class="py-line"><tt class="py-docstring">            - `s`: unicode</tt> </tt>
<a name="L151"></a><tt class="py-lineno">151</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L152"></a><tt class="py-lineno">152</tt>  <tt class="py-line"><tt class="py-docstring">        :raise JIDError: if the node name is too long.</tt> </tt>
<a name="L153"></a><tt class="py-lineno">153</tt>  <tt class="py-line"><tt class="py-docstring">        :raise pyxmpp.xmppstringprep.StringprepError: if the</tt> </tt>
<a name="L154"></a><tt class="py-lineno">154</tt>  <tt class="py-line"><tt class="py-docstring">            node name fails Nodeprep preparation."""</tt> </tt>
<a name="L155"></a><tt class="py-lineno">155</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">s</tt><tt class="py-op">:</tt> </tt>
<a name="L156"></a><tt class="py-lineno">156</tt>  <tt class="py-line">            <tt class="py-name">s</tt> <tt class="py-op">=</tt> <tt class="py-name">unicode</tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L157"></a><tt class="py-lineno">157</tt>  <tt class="py-line">            <tt class="py-name">s</tt><tt class="py-op">=</tt><tt id="link-43" class="py-name"><a title="pyxmpp.xmppstringprep.nodeprep" class="py-name" href="#" onclick="return doclink('link-43', 'nodeprep', 'link-2');">nodeprep</a></tt><tt class="py-op">.</tt><tt id="link-44" class="py-name" targets="Method pyxmpp.xmppstringprep.Profile.prepare()=pyxmpp.xmppstringprep.Profile-class.html#prepare"><a title="pyxmpp.xmppstringprep.Profile.prepare" class="py-name" href="#" onclick="return doclink('link-44', 'prepare', 'link-44');">prepare</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L158"></a><tt class="py-lineno">158</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">len</tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">.</tt><tt class="py-name">encode</tt><tt class="py-op">(</tt><tt class="py-string">"utf-8"</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">&gt;</tt><tt class="py-number">1023</tt><tt class="py-op">:</tt> </tt>
<a name="L159"></a><tt class="py-lineno">159</tt>  <tt class="py-line">                <tt class="py-keyword">raise</tt> <tt id="link-45" class="py-name"><a title="pyxmpp.exceptions.JIDError" class="py-name" href="#" onclick="return doclink('link-45', 'JIDError', 'link-6');">JIDError</a></tt><tt class="py-op">,</tt><tt class="py-string">"Node name too long"</tt> </tt>
<a name="L160"></a><tt class="py-lineno">160</tt>  <tt class="py-line">        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L161"></a><tt class="py-lineno">161</tt>  <tt class="py-line">            <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">None</tt> </tt>
<a name="L162"></a><tt class="py-lineno">162</tt>  <tt class="py-line">        <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-46" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-46', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-string">"node"</tt><tt class="py-op">,</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
</div><a name="L163"></a><tt class="py-lineno">163</tt>  <tt class="py-line"> </tt>
<a name="JID.__set_domain"></a><div id="JID.__set_domain-def"><a name="L164"></a><tt class="py-lineno">164</tt> <a class="py-toggle" href="#" id="JID.__set_domain-toggle" onclick="return toggle('JID.__set_domain');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__set_domain">__set_domain</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">s</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__set_domain-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__set_domain-expanded"><a name="L165"></a><tt class="py-lineno">165</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize `self.domain`</tt> </tt>
<a name="L166"></a><tt class="py-lineno">166</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L167"></a><tt class="py-lineno">167</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L168"></a><tt class="py-lineno">168</tt>  <tt class="py-line"><tt class="py-docstring">            - `s`: Unicode or UTF-8 domain part of the JID</tt> </tt>
<a name="L169"></a><tt class="py-lineno">169</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L170"></a><tt class="py-lineno">170</tt>  <tt class="py-line"><tt class="py-docstring">        :raise JIDError: if the domain name is too long."""</tt> </tt>
<a name="L171"></a><tt class="py-lineno">171</tt>  <tt class="py-line"> </tt>
<a name="L172"></a><tt class="py-lineno">172</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">s</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L173"></a><tt class="py-lineno">173</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt id="link-47" class="py-name"><a title="pyxmpp.exceptions.JIDError" class="py-name" href="#" onclick="return doclink('link-47', 'JIDError', 'link-6');">JIDError</a></tt><tt class="py-op">,</tt><tt class="py-string">"Domain must be given"</tt> </tt>
<a name="L174"></a><tt class="py-lineno">174</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">s</tt><tt class="py-op">:</tt> </tt>
<a name="L175"></a><tt class="py-lineno">175</tt>  <tt class="py-line">            <tt class="py-name">s</tt> <tt class="py-op">=</tt> <tt class="py-name">unicode</tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L176"></a><tt class="py-lineno">176</tt>  <tt class="py-line">        <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">idna</tt><tt class="py-op">.</tt><tt class="py-name">nameprep</tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L177"></a><tt class="py-lineno">177</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">len</tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">.</tt><tt class="py-name">encode</tt><tt class="py-op">(</tt><tt class="py-string">"utf-8"</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">&gt;</tt><tt class="py-number">1023</tt><tt class="py-op">:</tt> </tt>
<a name="L178"></a><tt class="py-lineno">178</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt id="link-48" class="py-name"><a title="pyxmpp.exceptions.JIDError" class="py-name" href="#" onclick="return doclink('link-48', 'JIDError', 'link-6');">JIDError</a></tt><tt class="py-op">,</tt><tt class="py-string">"Domain name too long"</tt> </tt>
<a name="L179"></a><tt class="py-lineno">179</tt>  <tt class="py-line">        <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-49" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-49', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-string">"domain"</tt><tt class="py-op">,</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
</div><a name="L180"></a><tt class="py-lineno">180</tt>  <tt class="py-line"> </tt>
<a name="JID.__set_resource"></a><div id="JID.__set_resource-def"><a name="L181"></a><tt class="py-lineno">181</tt> <a class="py-toggle" href="#" id="JID.__set_resource-toggle" onclick="return toggle('JID.__set_resource');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__set_resource">__set_resource</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">s</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__set_resource-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__set_resource-expanded"><a name="L182"></a><tt class="py-lineno">182</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize `self.resource`</tt> </tt>
<a name="L183"></a><tt class="py-lineno">183</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L184"></a><tt class="py-lineno">184</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L185"></a><tt class="py-lineno">185</tt>  <tt class="py-line"><tt class="py-docstring">            - `s`: Unicode or UTF-8 resource part of the JID</tt> </tt>
<a name="L186"></a><tt class="py-lineno">186</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L187"></a><tt class="py-lineno">187</tt>  <tt class="py-line"><tt class="py-docstring">        :raise JIDError: if the resource name is too long.</tt> </tt>
<a name="L188"></a><tt class="py-lineno">188</tt>  <tt class="py-line"><tt class="py-docstring">        :raise pyxmpp.xmppstringprep.StringprepError: if the</tt> </tt>
<a name="L189"></a><tt class="py-lineno">189</tt>  <tt class="py-line"><tt class="py-docstring">            node name fails Resourceprep preparation."""</tt> </tt>
<a name="L190"></a><tt class="py-lineno">190</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">s</tt><tt class="py-op">:</tt> </tt>
<a name="L191"></a><tt class="py-lineno">191</tt>  <tt class="py-line">            <tt class="py-name">s</tt> <tt class="py-op">=</tt> <tt class="py-name">unicode</tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L192"></a><tt class="py-lineno">192</tt>  <tt class="py-line">            <tt class="py-name">s</tt><tt class="py-op">=</tt><tt id="link-50" class="py-name"><a title="pyxmpp.xmppstringprep.resourceprep" class="py-name" href="#" onclick="return doclink('link-50', 'resourceprep', 'link-3');">resourceprep</a></tt><tt class="py-op">.</tt><tt id="link-51" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.prepare" class="py-name" href="#" onclick="return doclink('link-51', 'prepare', 'link-44');">prepare</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L193"></a><tt class="py-lineno">193</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">len</tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">.</tt><tt class="py-name">encode</tt><tt class="py-op">(</tt><tt class="py-string">"utf-8"</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">&gt;</tt><tt class="py-number">1023</tt><tt class="py-op">:</tt> </tt>
<a name="L194"></a><tt class="py-lineno">194</tt>  <tt class="py-line">                <tt class="py-keyword">raise</tt> <tt id="link-52" class="py-name"><a title="pyxmpp.exceptions.JIDError" class="py-name" href="#" onclick="return doclink('link-52', 'JIDError', 'link-6');">JIDError</a></tt><tt class="py-op">,</tt><tt class="py-string">"Resource name too long"</tt> </tt>
<a name="L195"></a><tt class="py-lineno">195</tt>  <tt class="py-line">        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L196"></a><tt class="py-lineno">196</tt>  <tt class="py-line">            <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">None</tt> </tt>
<a name="L197"></a><tt class="py-lineno">197</tt>  <tt class="py-line">        <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-53" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.__setattr__
pyxmpp.jid.JID.__setattr__" class="py-name" href="#" onclick="return doclink('link-53', '__setattr__', 'link-26');">__setattr__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-string">"resource"</tt><tt class="py-op">,</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
</div><a name="L198"></a><tt class="py-lineno">198</tt>  <tt class="py-line"> </tt>
<a name="JID.__str__"></a><div id="JID.__str__-def"><a name="L199"></a><tt class="py-lineno">199</tt> <a class="py-toggle" href="#" id="JID.__str__-toggle" onclick="return toggle('JID.__str__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__str__">__str__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__str__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__str__-expanded"><a name="L200"></a><tt class="py-lineno">200</tt>  <tt class="py-line">        <tt class="py-name">warnings</tt><tt class="py-op">.</tt><tt class="py-name">warn</tt><tt class="py-op">(</tt><tt class="py-string">"JIDs should not be used as strings"</tt><tt class="py-op">,</tt> <tt class="py-name">DeprecationWarning</tt><tt class="py-op">,</tt> <tt class="py-name">stacklevel</tt><tt class="py-op">=</tt><tt class="py-number">2</tt><tt class="py-op">)</tt> </tt>
<a name="L201"></a><tt class="py-lineno">201</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-54" class="py-name" targets="Method pyxmpp.jid.JID.as_utf8()=pyxmpp.jid.JID-class.html#as_utf8"><a title="pyxmpp.jid.JID.as_utf8" class="py-name" href="#" onclick="return doclink('link-54', 'as_utf8', 'link-54');">as_utf8</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L202"></a><tt class="py-lineno">202</tt>  <tt class="py-line"> </tt>
<a name="JID.__unicode__"></a><div id="JID.__unicode__-def"><a name="L203"></a><tt class="py-lineno">203</tt> <a class="py-toggle" href="#" id="JID.__unicode__-toggle" onclick="return toggle('JID.__unicode__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__unicode__">__unicode__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__unicode__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__unicode__-expanded"><a name="L204"></a><tt class="py-lineno">204</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-55" class="py-name" targets="Method pyxmpp.jid.JID.as_unicode()=pyxmpp.jid.JID-class.html#as_unicode"><a title="pyxmpp.jid.JID.as_unicode" class="py-name" href="#" onclick="return doclink('link-55', 'as_unicode', 'link-55');">as_unicode</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L205"></a><tt class="py-lineno">205</tt>  <tt class="py-line"> </tt>
<a name="JID.__repr__"></a><div id="JID.__repr__-def"><a name="L206"></a><tt class="py-lineno">206</tt> <a class="py-toggle" href="#" id="JID.__repr__-toggle" onclick="return toggle('JID.__repr__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__repr__">__repr__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__repr__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__repr__-expanded"><a name="L207"></a><tt class="py-lineno">207</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-string">"&lt;JID: %r&gt;"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-56" class="py-name"><a title="pyxmpp.jid.JID.as_unicode" class="py-name" href="#" onclick="return doclink('link-56', 'as_unicode', 'link-55');">as_unicode</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
</div><a name="L208"></a><tt class="py-lineno">208</tt>  <tt class="py-line"> </tt>
<a name="JID.as_utf8"></a><div id="JID.as_utf8-def"><a name="L209"></a><tt class="py-lineno">209</tt> <a class="py-toggle" href="#" id="JID.as_utf8-toggle" onclick="return toggle('JID.as_utf8');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#as_utf8">as_utf8</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.as_utf8-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.as_utf8-expanded"><a name="L210"></a><tt class="py-lineno">210</tt>  <tt class="py-line">        <tt class="py-docstring">"""UTF-8 encoded JID representation.</tt> </tt>
<a name="L211"></a><tt class="py-lineno">211</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L212"></a><tt class="py-lineno">212</tt>  <tt class="py-line"><tt class="py-docstring">        :return: UTF-8 encoded JID."""</tt> </tt>
<a name="L213"></a><tt class="py-lineno">213</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-57" class="py-name"><a title="pyxmpp.jid.JID.as_unicode" class="py-name" href="#" onclick="return doclink('link-57', 'as_unicode', 'link-55');">as_unicode</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">encode</tt><tt class="py-op">(</tt><tt class="py-string">"utf-8"</tt><tt class="py-op">)</tt> </tt>
</div><a name="L214"></a><tt class="py-lineno">214</tt>  <tt class="py-line"> </tt>
<a name="JID.as_string"></a><div id="JID.as_string-def"><a name="L215"></a><tt class="py-lineno">215</tt> <a class="py-toggle" href="#" id="JID.as_string-toggle" onclick="return toggle('JID.as_string');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#as_string">as_string</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.as_string-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.as_string-expanded"><a name="L216"></a><tt class="py-lineno">216</tt>  <tt class="py-line">        <tt class="py-docstring">"""UTF-8 encoded JID representation.</tt> </tt>
<a name="L217"></a><tt class="py-lineno">217</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L218"></a><tt class="py-lineno">218</tt>  <tt class="py-line"><tt class="py-docstring">        *Deprecated* Always use Unicode objects, or `as_utf8` if you really want.</tt> </tt>
<a name="L219"></a><tt class="py-lineno">219</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L220"></a><tt class="py-lineno">220</tt>  <tt class="py-line"><tt class="py-docstring">        :return: UTF-8 encoded JID."""</tt> </tt>
<a name="L221"></a><tt class="py-lineno">221</tt>  <tt class="py-line">        <tt class="py-name">warnings</tt><tt class="py-op">.</tt><tt class="py-name">warn</tt><tt class="py-op">(</tt><tt class="py-string">"JID.as_string() is deprecated. Use unicode() or `as_utf8` instead."</tt><tt class="py-op">,</tt> </tt>
<a name="L222"></a><tt class="py-lineno">222</tt>  <tt class="py-line">                 <tt class="py-name">DeprecationWarning</tt><tt class="py-op">,</tt> <tt class="py-name">stacklevel</tt><tt class="py-op">=</tt><tt class="py-number">1</tt><tt class="py-op">)</tt> </tt>
<a name="L223"></a><tt class="py-lineno">223</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-58" class="py-name"><a title="pyxmpp.jid.JID.as_utf8" class="py-name" href="#" onclick="return doclink('link-58', 'as_utf8', 'link-54');">as_utf8</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L224"></a><tt class="py-lineno">224</tt>  <tt class="py-line"> </tt>
<a name="JID.as_unicode"></a><div id="JID.as_unicode-def"><a name="L225"></a><tt class="py-lineno">225</tt> <a class="py-toggle" href="#" id="JID.as_unicode-toggle" onclick="return toggle('JID.as_unicode');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#as_unicode">as_unicode</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.as_unicode-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.as_unicode-expanded"><a name="L226"></a><tt class="py-lineno">226</tt>  <tt class="py-line">        <tt class="py-docstring">"""Unicode string JID representation.</tt> </tt>
<a name="L227"></a><tt class="py-lineno">227</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L228"></a><tt class="py-lineno">228</tt>  <tt class="py-line"><tt class="py-docstring">        :return: JID as Unicode string."""</tt> </tt>
<a name="L229"></a><tt class="py-lineno">229</tt>  <tt class="py-line">        <tt class="py-name">r</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-59" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-59', 'domain', 'link-11');">domain</a></tt> </tt>
<a name="L230"></a><tt class="py-lineno">230</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-60" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoInfo.node=pyxmpp.jabber.disco.DiscoInfo-class.html#node,Variable pyxmpp.jabber.disco.DiscoItem.node=pyxmpp.jabber.disco.DiscoItem-class.html#node,Variable pyxmpp.jabber.disco.DiscoItems.node=pyxmpp.jabber.disco.DiscoItems-class.html#node,Variable pyxmpp.jid.JID.node=pyxmpp.jid.JID-class.html#node"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-60', 'node', 'link-60');">node</a></tt><tt class="py-op">:</tt> </tt>
<a name="L231"></a><tt class="py-lineno">231</tt>  <tt class="py-line">            <tt class="py-name">r</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-61" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-61', 'node', 'link-60');">node</a></tt><tt class="py-op">+</tt><tt class="py-string">u'@'</tt><tt class="py-op">+</tt><tt class="py-name">r</tt> </tt>
<a name="L232"></a><tt class="py-lineno">232</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-62" class="py-name"><a title="pyxmpp.jid.JID.resource" class="py-name" href="#" onclick="return doclink('link-62', 'resource', 'link-12');">resource</a></tt><tt class="py-op">:</tt> </tt>
<a name="L233"></a><tt class="py-lineno">233</tt>  <tt class="py-line">            <tt class="py-name">r</tt><tt class="py-op">=</tt><tt class="py-name">r</tt><tt class="py-op">+</tt><tt class="py-string">u'/'</tt><tt class="py-op">+</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-63" class="py-name"><a title="pyxmpp.jid.JID.resource" class="py-name" href="#" onclick="return doclink('link-63', 'resource', 'link-12');">resource</a></tt> </tt>
<a name="L234"></a><tt class="py-lineno">234</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt id="link-64" class="py-name"><a title="pyxmpp.jid.JID" class="py-name" href="#" onclick="return doclink('link-64', 'JID', 'link-10');">JID</a></tt><tt class="py-op">.</tt><tt id="link-65" class="py-name"><a title="pyxmpp.cache
pyxmpp.jid.JID.cache" class="py-name" href="#" onclick="return doclink('link-65', 'cache', 'link-9');">cache</a></tt><tt class="py-op">.</tt><tt class="py-name">has_key</tt><tt class="py-op">(</tt><tt class="py-name">r</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L235"></a><tt class="py-lineno">235</tt>  <tt class="py-line">            <tt id="link-66" class="py-name"><a title="pyxmpp.jid.JID" class="py-name" href="#" onclick="return doclink('link-66', 'JID', 'link-10');">JID</a></tt><tt class="py-op">.</tt><tt id="link-67" class="py-name"><a title="pyxmpp.cache
pyxmpp.jid.JID.cache" class="py-name" href="#" onclick="return doclink('link-67', 'cache', 'link-9');">cache</a></tt><tt class="py-op">[</tt><tt class="py-name">r</tt><tt class="py-op">]</tt><tt class="py-op">=</tt><tt class="py-name">self</tt> </tt>
<a name="L236"></a><tt class="py-lineno">236</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">r</tt> </tt>
</div><a name="L237"></a><tt class="py-lineno">237</tt>  <tt class="py-line"> </tt>
<a name="JID.bare"></a><div id="JID.bare-def"><a name="L238"></a><tt class="py-lineno">238</tt> <a class="py-toggle" href="#" id="JID.bare-toggle" onclick="return toggle('JID.bare');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#bare">bare</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.bare-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.bare-expanded"><a name="L239"></a><tt class="py-lineno">239</tt>  <tt class="py-line">        <tt class="py-docstring">"""Make bare JID made by removing resource from current `self`.</tt> </tt>
<a name="L240"></a><tt class="py-lineno">240</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L241"></a><tt class="py-lineno">241</tt>  <tt class="py-line"><tt class="py-docstring">        :return: new JID object without resource part."""</tt> </tt>
<a name="L242"></a><tt class="py-lineno">242</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt id="link-68" class="py-name"><a title="pyxmpp.jid.JID" class="py-name" href="#" onclick="return doclink('link-68', 'JID', 'link-10');">JID</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-69" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-69', 'node', 'link-60');">node</a></tt><tt class="py-op">,</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-70" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-70', 'domain', 'link-11');">domain</a></tt><tt class="py-op">,</tt><tt class="py-name">check</tt><tt class="py-op">=</tt><tt class="py-name">False</tt><tt class="py-op">)</tt> </tt>
</div><a name="L243"></a><tt class="py-lineno">243</tt>  <tt class="py-line"> </tt>
<a name="JID.__eq__"></a><div id="JID.__eq__-def"><a name="L244"></a><tt class="py-lineno">244</tt> <a class="py-toggle" href="#" id="JID.__eq__-toggle" onclick="return toggle('JID.__eq__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__eq__">__eq__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">other</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__eq__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__eq__-expanded"><a name="L245"></a><tt class="py-lineno">245</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">other</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L246"></a><tt class="py-lineno">246</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">False</tt> </tt>
<a name="L247"></a><tt class="py-lineno">247</tt>  <tt class="py-line">        <tt class="py-keyword">elif</tt> <tt id="link-71" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoIdentity.type=pyxmpp.jabber.disco.DiscoIdentity-class.html#type"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-71', 'type', 'link-71');">type</a></tt><tt class="py-op">(</tt><tt class="py-name">other</tt><tt class="py-op">)</tt> <tt class="py-keyword">in</tt> <tt class="py-op">(</tt><tt class="py-name">str</tt><tt class="py-op">,</tt> <tt class="py-name">unicode</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L248"></a><tt class="py-lineno">248</tt>  <tt class="py-line">            <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L249"></a><tt class="py-lineno">249</tt>  <tt class="py-line">                <tt class="py-name">other</tt><tt class="py-op">=</tt><tt id="link-72" class="py-name"><a title="pyxmpp.jid.JID" class="py-name" href="#" onclick="return doclink('link-72', 'JID', 'link-10');">JID</a></tt><tt class="py-op">(</tt><tt class="py-name">other</tt><tt class="py-op">)</tt> </tt>
<a name="L250"></a><tt class="py-lineno">250</tt>  <tt class="py-line">            <tt class="py-keyword">except</tt><tt class="py-op">:</tt> </tt>
<a name="L251"></a><tt class="py-lineno">251</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">False</tt> </tt>
<a name="L252"></a><tt class="py-lineno">252</tt>  <tt class="py-line">        <tt class="py-keyword">elif</tt> <tt class="py-keyword">not</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt class="py-name">other</tt><tt class="py-op">,</tt><tt id="link-73" class="py-name"><a title="pyxmpp.jid.JID" class="py-name" href="#" onclick="return doclink('link-73', 'JID', 'link-10');">JID</a></tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L253"></a><tt class="py-lineno">253</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">False</tt> </tt>
<a name="L254"></a><tt class="py-lineno">254</tt>  <tt class="py-line"> </tt>
<a name="L255"></a><tt class="py-lineno">255</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-74" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-74', 'node', 'link-60');">node</a></tt><tt class="py-op">==</tt><tt class="py-name">other</tt><tt class="py-op">.</tt><tt id="link-75" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-75', 'node', 'link-60');">node</a></tt> </tt>
<a name="L256"></a><tt class="py-lineno">256</tt>  <tt class="py-line">            <tt class="py-keyword">and</tt> <tt class="py-name">are_domains_equal</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-76" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-76', 'domain', 'link-11');">domain</a></tt><tt class="py-op">,</tt><tt class="py-name">other</tt><tt class="py-op">.</tt><tt id="link-77" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-77', 'domain', 'link-11');">domain</a></tt><tt class="py-op">)</tt> </tt>
<a name="L257"></a><tt class="py-lineno">257</tt>  <tt class="py-line">            <tt class="py-keyword">and</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-78" class="py-name"><a title="pyxmpp.jid.JID.resource" class="py-name" href="#" onclick="return doclink('link-78', 'resource', 'link-12');">resource</a></tt><tt class="py-op">==</tt><tt class="py-name">other</tt><tt class="py-op">.</tt><tt id="link-79" class="py-name"><a title="pyxmpp.jid.JID.resource" class="py-name" href="#" onclick="return doclink('link-79', 'resource', 'link-12');">resource</a></tt><tt class="py-op">)</tt> </tt>
</div><a name="L258"></a><tt class="py-lineno">258</tt>  <tt class="py-line"> </tt>
<a name="JID.__ne__"></a><div id="JID.__ne__-def"><a name="L259"></a><tt class="py-lineno">259</tt> <a class="py-toggle" href="#" id="JID.__ne__-toggle" onclick="return toggle('JID.__ne__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__ne__">__ne__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">other</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__ne__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__ne__-expanded"><a name="L260"></a><tt class="py-lineno">260</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-keyword">not</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-80" class="py-name" targets="Method pyxmpp.jid.JID.__eq__()=pyxmpp.jid.JID-class.html#__eq__,Method pyxmpp.stanza.Stanza.__eq__()=pyxmpp.stanza.Stanza-class.html#__eq__"><a title="pyxmpp.jid.JID.__eq__
pyxmpp.stanza.Stanza.__eq__" class="py-name" href="#" onclick="return doclink('link-80', '__eq__', 'link-80');">__eq__</a></tt><tt class="py-op">(</tt><tt class="py-name">other</tt><tt class="py-op">)</tt> </tt>
</div><a name="L261"></a><tt class="py-lineno">261</tt>  <tt class="py-line"> </tt>
<a name="JID.__cmp__"></a><div id="JID.__cmp__-def"><a name="L262"></a><tt class="py-lineno">262</tt> <a class="py-toggle" href="#" id="JID.__cmp__-toggle" onclick="return toggle('JID.__cmp__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__cmp__">__cmp__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">other</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__cmp__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__cmp__-expanded"><a name="L263"></a><tt class="py-lineno">263</tt>  <tt class="py-line">        <tt class="py-name">a</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-81" class="py-name"><a title="pyxmpp.jid.JID.as_unicode" class="py-name" href="#" onclick="return doclink('link-81', 'as_unicode', 'link-55');">as_unicode</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L264"></a><tt class="py-lineno">264</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">cmp</tt><tt class="py-op">(</tt><tt class="py-name">a</tt><tt class="py-op">,</tt><tt class="py-name">other</tt><tt class="py-op">)</tt> </tt>
</div><a name="L265"></a><tt class="py-lineno">265</tt>  <tt class="py-line"> </tt>
<a name="JID.__hash__"></a><div id="JID.__hash__-def"><a name="L266"></a><tt class="py-lineno">266</tt> <a class="py-toggle" href="#" id="JID.__hash__-toggle" onclick="return toggle('JID.__hash__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jid.JID-class.html#__hash__">__hash__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="JID.__hash__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="JID.__hash__-expanded"><a name="L267"></a><tt class="py-lineno">267</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">hash</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-82" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-82', 'node', 'link-60');">node</a></tt><tt class="py-op">)</tt><tt class="py-op">^</tt><tt class="py-name">hash</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-83" class="py-name"><a title="pyxmpp.jid.JID.domain" class="py-name" href="#" onclick="return doclink('link-83', 'domain', 'link-11');">domain</a></tt><tt class="py-op">)</tt><tt class="py-op">^</tt><tt class="py-name">hash</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-84" class="py-name"><a title="pyxmpp.jid.JID.resource" class="py-name" href="#" onclick="return doclink('link-84', 'resource', 'link-12');">resource</a></tt><tt class="py-op">)</tt> </tt>
</div></div><a name="L268"></a><tt class="py-lineno">268</tt>  <tt class="py-line"> </tt>
<a name="L269"></a><tt class="py-lineno">269</tt>  <tt class="py-line"><tt class="py-comment"># vi: sts=4 et sw=4</tt> </tt>
<a name="L270"></a><tt class="py-lineno">270</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:06 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
